<template>
  <div class="compare-detail mb30">
    <div class="sticky compare-detail_header">
      <div class="container">
        <div class="warp-list-product">
          <div class="list-product">
            <div
              v-for="(item, index) in comparesMax"
              :key="item.sku"
              class="items"
              :class="{ 'items no-border': index == 3 }"
            >
              <nuxt-link
                class="ava"
                :to="'/' + item.shared_url + '?option=' + item.sku"
              >
                <img
                  v-if="item.thumbnail != '/'"
                  class="lazyload"
                  :data-src="
                    resizeImage(baseImageUrl + item.thumbnail, 154, 154)
                  "
                  alt="product image"
                />
                <img
                  v-else
                  src="/images/placeholder/placeholder-small.svg"
                  alt="product image"
                />
              </nuxt-link>
              <div class="content">
                <h4 class="name">
                  <nuxt-link
                    :to="'/' + item.shared_url + '?option=' + item.sku"
                  >
                    {{ item.name }}
                  </nuxt-link>
                </h4>
                <div class="flex space-between">
                  <div class="code txt_12">SKU: {{ item.sku }}</div>
                  <!-- <ul class="list-star">
                    <li class="active">
                      <a href="javascript:;">
                        <svg-icon
                          name="star-full"
                          class="inline-block align-middle"
                        ></svg-icon>
                      </a>
                    </li>
                    <li class="active">
                      <a href="javascript:;">
                        <svg-icon
                          name="star-full"
                          class="inline-block align-middle"
                        ></svg-icon>
                      </a>
                    </li>
                    <li class="active">
                      <a href="javascript:;">
                        <svg-icon
                          name="star-full"
                          class="inline-block align-middle"
                        ></svg-icon>
                      </a>
                    </li>
                    <li class="active">
                      <a href="javascript:;">
                        <svg-icon
                          name="star-full"
                          class="inline-block align-middle"
                        ></svg-icon>
                      </a>
                    </li>
                    <li>
                      <a href="javascript:;">
                        <svg-icon
                          name="star-none"
                          class="inline-block align-middle"
                        ></svg-icon>
                      </a>
                    </li>
                  </ul> -->
                </div>
                <div class="price">
                  <strong>
                    {{ (item.sale_price || item.price) | formatNumber }}
                  </strong>
                </div>
                <a
                  class="btn-default"
                  href="javascript:;"
                  @click.prevent="addToCart(item)"
                >
                  Thêm vào giỏ hàng
                </a>
              </div>
              <a
                class="delete"
                href="javascript:;"
                @click.prevent="removeCompare(index)"
              >
                ×
              </a>
            </div>
            <div v-if="isCompareLast == false" class="items pendding no-border">
              <template v-if="compares[3]">
                <nuxt-link
                  class="ava"
                  :to="
                    '/' + compares[3].shared_url + '?option=' + compares[3].sku
                  "
                >
                  <img
                    v-if="compares[3].thumbnail != '/'"
                    class="lazyload"
                    :data-srcset="
                      resizeImage(baseImageUrl + compares[3].thumbnail, 80, 80)
                    "
                    alt="product image"
                  />
                  <img
                    v-else
                    src="/images/placeholder/placeholder-small.svg"
                    alt="product image"
                  />
                </nuxt-link>
                <div class="content">
                  <h4 class="name">
                    <nuxt-link
                      :to="
                        '/' +
                        compares[3].shared_url +
                        '?option=' +
                        compares[3].sku
                      "
                    >
                      {{ compares[3].name }}
                    </nuxt-link>
                  </h4>
                  <div class="code txt_12">SKU: {{ compares[3].sku }}</div>
                  <div class="price">
                    <strong>
                      {{
                        (compares[3].sale_price || compares[3].price)
                          | formatNumber
                      }}
                    </strong>
                  </div>
                </div>
                <a
                  class="btn-default white"
                  href="javascript:;"
                  @click="moreCompare()"
                >
                  Thêm vào so sánh
                </a>
              </template>
              <!-- <a class="add-compare" href="javascript:;">
                <svg-icon
                  name="plus-circle-1"
                  class="inline-block align-middle"
                ></svg-icon>
                Thêm sản phẩm khác
              </a> -->
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="compare-detail_info">
      <div class="container">
        <div class="d-flex tr collapse-list">
          <div class="compare-name td">
            <div v-for="spec in Object.keys(speclist)" :key="spec" class="td">
              <h3>{{ spec }}</h3>
              <div
                v-for="spec_child in speclist[spec]"
                :key="spec_child"
                class="compare-name-child"
              >
                {{ spec_child }}
              </div>
            </div>
          </div>
          <div
            v-for="(sp, index) in details"
            :key="'sp' + index"
            class="compare-content-item td"
          >
            <div
              v-for="(ites, index1) in sp"
              :key="'ites' + index1"
              class="compare-content_value"
            >
              <div v-if="ites.length > 1" class="empty">Empty</div>
              <div
                v-for="(iteeee, index2) in ites"
                :key="'sdsdsd' + index2"
                :class="{
                  'empty-value': iteeee == '' || iteeee == null,
                  isheading: ites.length == 1,
                }"
              >
                {{ iteeee != '' && iteeee != null ? iteeee : 'empty-value' }}
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Helper from '../../../assets/config'
export default {
  name: 'ProductDetailCompare',
  data() {
    return {
      isCompareLast: false,
      compares: null,
      comparesMax: null,
      details: [],
      speclist: {},
      options: [],
    }
  },
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
  },
  created() {
    this.compares = this.$store.state.compares
    const products = this.$store.state.compares
    this.comparesMax = products.length === 4 ? products.slice(0, -1) : products
    // eslint-disable-next-line no-var
    var listSku = []
    this.comparesMax.forEach(function (item) {
      listSku.push(item.sku)
    })
    this.getDetails({ options: listSku })
    this.getSpecList()
  },
  methods: {
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    addToCart(product) {
      this.$store.commit('add', product)
    },
    removeCompare(index) {
      this.$store.commit('removecompare', index)
      this.comparesMax = this.compares
      const listSku = []
      this.comparesMax.forEach(function (item) {
        listSku.push(item.sku)
      })
      this.getDetails({ options: listSku })
    },
    moreCompare() {
      this.isCompareLast = true
      this.comparesMax = this.compares
      const listSku = []
      this.comparesMax.forEach(function (item) {
        listSku.push(item.sku)
      })
      this.getDetails({ options: listSku })
    },
    getDetails(options) {
      this.$axios.$post('/sosanh/skus/list', options).then((res) => {
        this.details = res
      })
    },
    getSpecList() {
      this.$axios.$get('/sosanh/specs/list').then((res) => {
        this.speclist = res
      })
    },
  },
}
</script>
